"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class InterpretationRequestRD(ProtocolElement):
    """
    This record represents basic information for this report
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "BAMs",
        "InterpretationRequestID",
        "InterpretationRequestVersion",
        "TieredVariants",
        "TieringVersion",
        "VCFs",
        "analysisReturnURI",
        "modeOfInheritance",
        "pedigree",
        "versionControl",
        "workspace",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_2_1_0 import reports as reports_2_1_0

        return {
            "BAMs": reports_2_1_0.File,
            "TieredVariants": reports_2_1_0.ReportedVariant,
            "VCFs": reports_2_1_0.File,
            "annotationFile": reports_2_1_0.File,
            "bigWigs": reports_2_1_0.File,
            "otherFamilyHistory": reports_2_1_0.OtherFamilyHistory,
            "pedigree": reports_2_1_0.Pedigree,
            "pedigreeDiagram": reports_2_1_0.File,
            "versionControl": reports_2_1_0.VersionControl,
            "virtualPanel": reports_2_1_0.VirtualPanel,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_2_1_0 import reports as reports_2_1_0

        return {
            "complexGeneticPhenomena": reports_2_1_0.ComplexGeneticPhenomena,
            "modeOfInheritance": reports_2_1_0.ModeOfInheritance,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_2_1_0 import reports as reports_2_1_0

        return {
            "Gel_BioInf_Models.File": reports_2_1_0.File,
            "Gel_BioInf_Models.ReportedVariant": reports_2_1_0.ReportedVariant,
            "Gel_BioInf_Models.File": reports_2_1_0.File,
            "Gel_BioInf_Models.File": reports_2_1_0.File,
            "Gel_BioInf_Models.File": reports_2_1_0.File,
            "Gel_BioInf_Models.ComplexGeneticPhenomena": reports_2_1_0.ComplexGeneticPhenomena,
            "Gel_BioInf_Models.ModeOfInheritance": reports_2_1_0.ModeOfInheritance,
            "Gel_BioInf_Models.OtherFamilyHistory": reports_2_1_0.OtherFamilyHistory,
            "Gel_BioInf_Models.Pedigree": reports_2_1_0.Pedigree,
            "Gel_BioInf_Models.File": reports_2_1_0.File,
            "Gel_BioInf_Models.VersionControl": reports_2_1_0.VersionControl,
            "Gel_BioInf_Models.VirtualPanel": reports_2_1_0.VirtualPanel,
            "Gel_BioInf_Models.InterpretationRequestRD": reports_2_1_0.InterpretationRequestRD,
        }

    __slots__ = [
        "BAMs",
        "InterpretationRequestID",
        "InterpretationRequestVersion",
        "TieredVariants",
        "TieringVersion",
        "VCFs",
        "analysisReturnURI",
        "modeOfInheritance",
        "pedigree",
        "versionControl",
        "workspace",
        "additionalInfo",
        "analysisVersion",
        "annotationFile",
        "bigWigs",
        "cellbaseVersion",
        "complexGeneticPhenomena",
        "genomeAssemblyVersion",
        "interpretGenome",
        "otherFamilyHistory",
        "pedigreeDiagram",
        "virtualPanel",
    ]

    def __init__(
        self,
        BAMs,
        InterpretationRequestID,
        InterpretationRequestVersion,
        TieredVariants,
        TieringVersion,
        VCFs,
        analysisReturnURI,
        modeOfInheritance,
        pedigree,
        versionControl,
        workspace,
        additionalInfo=None,
        analysisVersion="1",
        annotationFile=None,
        bigWigs=None,
        cellbaseVersion="4.0",
        complexGeneticPhenomena=None,
        genomeAssemblyVersion="GRCh37.p13",
        interpretGenome=False,
        otherFamilyHistory=None,
        pedigreeDiagram=None,
        virtualPanel=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_2_1_0.InterpretationRequestRD model.

        :param BAMs:
            BAMs Files
        :type BAMs: list[File]
        :param InterpretationRequestID:
            Unique id for this report
        :type InterpretationRequestID: str
        :param InterpretationRequestVersion:
            Version of this request
        :type InterpretationRequestVersion: int
        :param TieredVariants:
            Tiered Variants
        :type TieredVariants: list[ReportedVariant]
        :param TieringVersion:
            Tiering Version
        :type TieringVersion: str
        :param VCFs:
            VCFs Files where SVs and CNVs are represented
        :type VCFs: list[File]
        :param analysisReturnURI:
            name of the directory or endpoint where the analysed genome will be
            returned.
        :type analysisReturnURI: str
        :param modeOfInheritance:
            Mode of inheritance to analyze the family
        :type modeOfInheritance: ModeOfInheritance
        :param pedigree:
            Pedigree of the family to analyze
        :type pedigree: Pedigree
        :param versionControl:
            Model version number
        :type versionControl: VersionControl
        :param workspace:
            The genome shall be assigned to the workspaces(projects or domains
            with a predefined set of users) to control user access
        :type workspace: list[str]
        :param additionalInfo:
            Additional information
        :type additionalInfo: None | dict[str, str]
        :param analysisVersion:
            In the event that the provider has multiple versions of their system
            and an analysis will need to be provided against     a
            particular version, then that version goes here.
        :type analysisVersion: str
        :param annotationFile:
            Variant Annotation using cellbase
        :type annotationFile: None | File
        :param bigWigs:
            BigWig Files
        :type bigWigs: None | list[File]
        :param cellbaseVersion:
            Cellbase version
        :type cellbaseVersion: str
        :param complexGeneticPhenomena:
            Complex Genetic Phenomena
        :type complexGeneticPhenomena: None | ComplexGeneticPhenomena
        :param genomeAssemblyVersion:
            This is the version of the assembly used to align the reads
        :type genomeAssemblyVersion: str
        :param interpretGenome:
            Load data to system or also provide interpretation?
        :type interpretGenome: boolean
        :param otherFamilyHistory:
            It is paternal or maternal with reference to the participant.
        :type otherFamilyHistory: None | OtherFamilyHistory
        :param pedigreeDiagram:
            Pedigree Diagram Files as an SGV
        :type pedigreeDiagram: None | File
        :param virtualPanel:
            Virtual Panels can be defined using EnsmbleIds, Transcripts, a BED
            File or a VCF File
        :type virtualPanel: None | list[VirtualPanel]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.1.0"
